;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -( SYSTEM  )
MATH_HARDWARE - determines if 80x87 math coprocessor is installed
;
; inputs:    none
; 
; output:    AX = code for 80x87 model
;            0 = not installed
;            1 = 8087
;            2 = 287
;            3 = 387 (DX or SX)
;            4 = 487 (486DX or 487SX)
;            If the coprocessor is present, it is initilaized by MATH_HARDWARE.
;            
;* * * * * * * * * * * * * *

	public	MATH_HARDWARE
MATH_HARDWARE	PROC	FAR
     XOR     AX,AX
     PUSH    AX
     POPF
     PUSHF
     POP     AX
     AND     AX,0F000h
     CMP     AX,0F000h
     JZ      math_2
     INT     11h
     AND     AX,0002
     JZ      math_exit1			;jmp if no math chip
     PUSH    BP
     MOV     BP,SP
     SUB     SP,+04
     MOV     WORD PTR [BP-04],0000
     MOV     WORD PTR [BP-02],7F80h
     FLD     DWORD PTR [BP-04]
     FLD     ST(0)
     FCHS
     FCOMPP
     FSTSW   [BP-02]
     MOV     AX,[BP-02]
     MOV     SP,BP
     POP     BP
     SAHF
     MOV     AX,0002			;load code for 287
     JZ      math_exit1			;jmp if 287
     CALL    FIND_CPU_TYPE
math_exit1:
     RETF
math_2:
     PUSH    BP
     MOV     BP,SP
     SUB     SP,+02
     XOR     DX,DX
     MOV     [BP-02],DX
     FINIT
     FSTCW   [BP-02]
     PUSH    CX
math_3:
     MOV     CX,0003
     LOOP    math_3
     POP     CX
     MOV     AX,[BP-02]
     AND     AX,0300h
     CMP     AX,0300h
     JNZ     math_exit2		;jmp if no math chip
     INC     DX			;set dx=1 (8087)
math_exit2:
     MOV     AX,DX
     MOV     SP,BP
     POP     BP
     RETF
MATH_HARDWARE	ENDP
