;--------------------------------------------------------------------
; mem_avail - procedure to determine available memory
;
mem_avail:
;
; get memory size from low ram
;
        sub     bx,bx
        mov     es,bx
        mov     bx,413h                 ;get address of mem. avail. in es:bx
        mov     cx,es:[bx]              ;get mem. size in 1k blocks
        mov     CONVENTIONAL_TOTAL,cx   ;save total memory size
        shl     cx,1                    ;convert to 512 byte block count
        shl     cx,1                    ;convert to 256 byte block count
        shl     cx,1                    ;convert to 128 byte block count
        shl     cx,1                    ;convert to 64 byte block count
        shl     cx,1                    ;convert to 32 byte block count
        shl     cx,1                    ;convert to 16 byte block count
;
; compute our final program location in paragraphs
;  ax = our final offset
;
        mov     ax,program_end_seg      ;get seg beyond our program
        cmp     ax,0
        jnz     compute_remaining_mem   ;jump if memory allocated
        mov     bx,cs   ;get our segment
        add     ax,bx   ;compute final program paragraph address
;
; compute the amount of memory remaining in paragraphs
;
compute_remaining_mem:
        sub     cx,ax
;
; convert memory available to 1k blocks
;
        mov     ax,cx
        mov     cl,6
        shr     ax,cl
        sub     dx,dx
        mov     CONVENTIONAL_AVAIL,ax   ;save available 1k blocks
