;---------------------
; find_first_display_mcb - subroutine to find mcb chain
;   output -  es:00 points at chain start
;
find_first_mcb:
	mov	current_mcb_seg,50h			;start search at 50:0
	mov	es,current_mcb_seg
	sub	di,di
d_find1:
	cmp	es:[di.d_mcb_code1],4dh
	je	d_find3			;jump if possible start
d_find2:
	mov	ax,es
	inc	ax
	mov	es,ax			;move to next paragraph
	jmp	d_find1			;loop till trial start found
d_find3:
	mov	current_mcb_seg,es		;save trial start
d_find4:
	mov	bx,es
	add	bx,es:[di.d_mcb_len1]	;conpute next mcb position
	cmp	ax,bx			;check if segment changed
	jae	d_find2			;try again if new segment is wrong
	mov	dx,cs
	cmp	bx,dx
	jae	d_find2			;jmp if out of range
	inc	bx			;move forward one paragraph
	mov	es,bx
	cmp	es:[di.d_mcb_code1],4dh	;check if next mcb is ok
	je	d_find4			;jump if mcb ok
	cmp	es:[di.d_mcb_code1],5ah	;check if last mcb
	je	d_find5			;jump if end of chain found
;
; bad code found, this must not be the real mcb chain
;
	mov	es,current_mcb_seg
	jmp	d_find2
;
; end of chain found ok
;
d_find5:
	mov	es,current_mcb_seg		;restore ptr to start of mcb chain
	ret
;--------------------------------------------------------------------------
; move to next mcb
;  inputs:  es:0  points at current mcb
;  output:  es:0  points at next mcb
;
next_mcb:
	push	bx
	mov	bx,es
	add	bx,es:[d_mcb_len1]	;conpute next mcb position
	inc	bx			;move forward one paragraph
	mov	es,bx
	pop	bx
	ret
;--------------------------------------------------------------------------
; find_first_display_mcb - subroutine to find mcb chain
;   output -  es:di points at chain start
;             carry set if found start
;             carry cleared if start not found
;
mcb_starts	dw	50 dup (0)	;table of mcb starts
;
find_first_display_mcb:
	mov	ah,52h			;get ptr to DOS lists
	int	21h			;  in es:bx
	mov	es,es:[bx-2]		;get mcb pointer from list
	cmp	es:[d_mcb_code1],4dh
	jne	start_not_found		;jmp if not start of mcb
	mov	current_mcb_seg,es	;save trial start
;
; build array of mcb starts
;
	mov	di,offset mcb_starts
	mov	cx,48
sav_mcbs:
	mov	[di],es			;save this mcb start
	cmp	es:[d_mcb_code1],'Z'	;check if end of chain
	je	d_find_ok		; and jmp if found
	call	next_mcb
	add	di,2			;move to next array store pnt
	loop	sav_mcbs		;loop till done
;
; error found
;
start_not_found:
	clc
	jmp	d_find7
d_find_ok:
	mov	es,current_mcb_seg
	stc
d_find7:
	ret
;-----------------------------------------------------------------------------
