
PAGE  60,132
;
; This program will search memory for the programs in the table
; cmp_list.  If found they will be displayed.
;
;mcbscan.exe:	mcbscan.obj
;		tlink /t mcbscan,mcbscan.com
;		tlink /x /v /m mcbscan
;		ts mcbscan.map
;		erase mcbscan.exe
;		erase mcbscan.map
;
;mcbscan.obj:	mcbscan.asm
;		tasm /zi mcbscan.asm
;


code	segment
	assume	cs:code,ds:code,es:code

	org	100h
start:	jmp	begin
	
buffer	db	2048 dup (0)
stack_start	dw	0

mcb_msg1 db 0dh,0ah,'$'
mcb_msg2 db ' have $'
mcb_msg3 db ' has $'
mcb_msg4 db 'been found in memory.'
         db 0dh,0ah,'$'
mcb_msg5 db ', $'


cmp_list	label	byte
	db	'SMARTDRV.EXE',0
	db	'Smartdrv$',0
	
	db	'SK.COM',0
	db	'Sidekick$',0

	DB	0			;END OF LIST
	
mcb_srch_state	db	0		;0 = all ok, 1+ = names found

begin:
	mov	ax,cs
	mov	ss,ax
	mov	sp,offset stack_start
	mov	ds,ax
	call	mcb_scan
	
	mov	ax,4c00h
	int	21h
	
;--------------------------------------------------------------------------
; search the mcb chain for illegal programs in front of this program
;   inputs:  cmp_list (terminated with a zero
;   output:  carry set if illegal name found
;
mcb_scan:
	call	find_first_mcb
	mov	ax,5803h			;set DOS 5 mcb chain
	mov	bx,0001h			;  to use umb's
	int	21h	
mcb_srch_loop:
	call	find_name			;look in mcb for program name
	jnc	mcb_srch_cont			;jmp if name not found
	call	compare_name
	jnc	mcb_srch_cont			;jmp if ok
	cmp	mcb_srch_state,0		;check if any other matches
	jne	dsp_mcb_name1			;jmp if other matches
	mov	dx,offset mcb_msg1
	mov	ah,9
	int	21h
	jmp	dsp_mcb_name2
dsp_mcb_name1:
	mov	dx,offset mcb_msg5		;text ', '
	mov	ah,9
	int	21h
;
; move name match to match_name and put '$' at end
;
dsp_mcb_name2:					;display name in mcb
	mov	dx,si				;save ptr to match name
;
; display match name
;
	mov	ah,9
	int	21h
	inc	mcb_srch_state			;bump names found count	
mcb_srch_cont:
	call	get_next_mcb
	cmp	es:[mcb_code1],'Z'
	je	mcb_srch_done
	jmp	mcb_srch_loop	
mcb_srch_done:
	cmp	mcb_srch_state,0
	je	mcb_srch_exit1			;jmp if no matches
	mov	dx,offset mcb_msg3
	cmp	mcb_srch_state,1
	je	have_has_disp
	mov	dx,offset mcb_msg2
have_has_disp:
	mov	ah,9
	int	21h
	mov	ah,9
	mov	dx,offset mcb_msg4		;message tail
	int	21h
	stc					;set carry if illegal name found
	jmp	mcb_srch_exit2
mcb_srch_exit1:
	clc					;clear carry if no matches
mcb_srch_exit2:
	pushf					;save exit state
	mov	ax,5803h			;remove
	mov	bx,0000h			; high memory from mcb chain
	int	21h
	popf
	ret
;---------------------------------------------------------------------------

MCB	STRUC
  mcb_code1	db	0		;4d=start 5a=end
  prog_seg1	dw	0		;program segment
  mcb_len1	dw	0		;length of memory ctrl	block
MCB	ENDS

current_mcb_seg	dw	0
;-------------------------------------
; move es: to next mcb
;
get_next_mcb:
	mov	bx,es
	add	bx,es:[mcb_len1]	;conpute next mcb position
	inc	bx			;move	forward	one paragraph
	mov	es,bx
	ret
;---------------------
; find_first_display_mcb - subroutine to find mcb chain
;   output -  es:00 points at chain start
;
find_first_mcb:
	mov	current_mcb_seg,50h			;start search at 50:0
	mov	es,current_mcb_seg
	sub	di,di
d_find1:
	cmp	es:[di.mcb_code1],4dh
	je	d_find3			;jump if possible	start
d_find2:
	mov	ax,es
	inc	ax
	mov	es,ax			;move to next paragraph
	jmp	d_find1			;loop till trial	start found
d_find3:
	mov	current_mcb_seg,es		;save trial start
d_find4:
	mov	bx,es
	add	bx,es:[di.mcb_len1]	;conpute next mcb position
	cmp	ax,bx			;check if segment changed
	jae	d_find2			;try again if new segment is wrong
	mov	dx,cs
	cmp	bx,dx
	jae	d_find2			;jmp if out of range
	inc	bx			;move	forward	one paragraph
	mov	es,bx
	cmp	es:[di.mcb_code1],4dh	;check if next mcb	is ok
	je	d_find4			;jump if mcb ok
	cmp	es:[di.mcb_code1],5ah	;check if last mcb
	je	d_find5			;jump if end of chain found
;
; bad code found, this must not	be the real mcb	chain
;
d_find4a:
	mov	es,current_mcb_seg
	jmp	d_find2
;
; end of chain found ok
;
d_find5:
	mov	ax,ds
;
; The mcb structure looks correct, but just to be sure check if the last
; mcb is our executing program.
;
	dec	ax
	cmp	ax,bx
	jne	d_find4a			;jmp if last mcb is wrong
	mov	es,current_mcb_seg		;restore ptr to start of mcb chain
	ret
;---------------------------------------------------------------------------
; scan current mcb to see if name is present
;  inputs:  es:0 is mcb
;  output:  carry set if name found and es:di points at name
;
find_name:
	mov	ax,es:[mcb_len1]		;get paragraph size of mcb
	cmp	ax,4096/16			;check if mcb too big for envior
	jae	fn_no_name			;jmp if no name found
	mov	cl,4
	shl	ax,cl				;convert to byte size
	mov	cx,ax				;set loop count
	mov	di,16				;start scan from loc. 16
fn_scan_lp:
	cmp	word ptr es:[di],0
	jne	fn_nxt_loc
	cmp	word ptr es:[di+2],0001
	je	fn_name_ck			;jmp if possible name start
fn_nxt_loc:
	inc	di
	loop	fn_scan_lp			;loop till name start fnd
	jmp	fn_no_name			;jmp if name not found
;
; we have found 00,00,01,00 now verify a name is present
;
fn_name_ck:
	add	di,4				;move past 00,00,01,00
	cmp	byte ptr es:[di],20h
	jb	fn_no_name			;jmp if name is illegal
	cmp	byte ptr es:[di],80h
	jae	fn_no_name			;jmp if name is illegal
	
;
; verify a zero is at end of name
;
	mov	cx,45				;max path size
	dec	di				;adjust for pre increment
fn_zero_scan:
	inc	di
	cmp	byte ptr es:[di],0
	je	fn_fnd_zero			;jmp if expected zero found
	cmp	byte ptr es:[di],20h
	jb	fn_no_zero			;jmp if name is illegal
	cmp	byte ptr es:[di],80h
	jae	fn_no_zero			;jmp if name is illegal
	loop	fn_zero_scan
fn_no_zero:
	jmp	fn_no_name			;jmp if no zero at end of name
;
; we have found 00,00,01,00 followed by what appears to be a valid name
; scan back till start of name found
;
fn_fnd_zero:
	dec	di
	cmp	byte ptr es:[di],0
	je	fn_name_strt
	cmp	byte ptr es:[di],'\'
	je	fn_name_strt
	cmp	byte ptr es:[di],':'
	jne	fn_fnd_zero
;
; es:di now points at start of name -1
;
fn_name_strt:
	inc	di				;move to name start
	stc
	jmp	fn_exit
fn_no_name:
	clc
fn_exit:
	ret
;---------------------------------------------------------------------------
; compare name in mcb to list at cmp_list
;  inputs: es:di points at mcb name
;  output: carry set if match, and ds:si point at match name
;
mcb_name_ptr	dw	0

compare_name:
	mov	mcb_name_ptr,di
	mov	si,offset cmp_list
	cld
cn_loop:
	mov	al,byte ptr es:[di]		;get mcb char.
	cmp	al,'Z'
	jb	cn_upper
	sub	al,20h				;convert to upper case
cn_upper:
	cmp	al,byte ptr ds:[si]
	jne	cn_miscompare			;jmp if different
	cmp	al,0
	je	cn_match			;jmp if name matches
	inc	si
	inc	di
	jmp	cn_loop				;loop till all of name compared
;
; we have a miscompare, check if more entries on list
;    ds:si points at compare table
;    es:di points at mcb name
;
cn_miscompare:
	mov	di,mcb_name_ptr			;restore di
	cmp	byte ptr ds:[si],0		;check if end of name
	je	cn_name_end
	inc	si
	jmp	cn_miscompare			;loop till end of name
cn_name_end:
;
; scan past second name of matched pair
;
cn_miscompare2:
	mov	di,mcb_name_ptr			;restore di
	cmp	byte ptr ds:[si],0		;check if end of name
	je	cn_name_end2
	inc	si
	jmp	cn_miscompare2			;loop till end of name
cn_name_end2:
;
; check if end of compare list
;
	inc	si				;move to start of next name
	cmp	byte ptr ds:[si],0
	jne	cn_loop				;loop if another name on list
	clc
	jmp	cn_exit				;jmp if no matches
cn_match:
	inc	si				;move to start of match name
	stc
cn_exit:
	mov	di,mcb_name_ptr			;restore -di-
	ret
;---------------------------------------------------------------------------
code	ends

	end	start
