;
; check if emm is available
;
m_emm_init:
	push	es
	push	ds
	push	cs
	pop	ds
	mov	ah,3dh		;open code
	lea	dx,ASCII_device_name
	mov	al,0
	int	21h
	jc	m_emm_error
	mov	bx,ax		;get file handle from DOS
	mov	ax,4400h	;issue ioctl
	int	21h
	jc	m_emm_error
	test	dx,0080h	;check if device or file
	jz	m_emm_error
	mov	ah,44h		;ioctl
	mov	dx,offset dummy_buffer	;
	mov	cx,0
	mov	al,07h
	int	21h		;request status
	jc	m_emm_error
	push	ax
	mov	ah,3eh
	int	21h		;close file handle
	pop	ax
	cmp	al,0ffh
	jne	m_emm_error
	pop	ds
	jmp	short m_emm_is_present
;
m_emm_error:
	pop	ds
m_emm_errorx:
	jmp	m_emm_init_done
m_emm_is_present:
	mov	ah,46h			;get version # code
	int	67h
	or	ah,ah			;check if version returned
	jnz	m_emm_errorx
;	db	0d4h,010h		;aam 10h (convert to hex)
;	or	ax,'00'
;	mov	byte ptr emm_version,ah
;	mov	byte ptr emm_version+2,al
	mov	ah,41h			;get page frame address
	int	67h
	or	ah,ah
	jnz	m_emm_errorx		;jump if error
	mov	ah,42h			;get avail. page count
	int	67h
	or	ah,ah
	jnz	m_emm_errorx		;jump if error
	shl	bx,1			;convert
	shl	bx,1			;  16k blocks count
	shl	bx,1			;    to 1k block count
	shl	bx,1			;       by multiplying by 16
	mov	m_emm_MEM_AVAIL,bx	;save available memory.
	shl	dx,1
	shl	dx,1
	shl	dx,1
	shl	dx,1
	mov	m_emm_MEM_TOTAL,dx	;save total 1k blocks
m_emm_init_done:
	ret

m_emm_MEM_AVAIL	dw	0		;largest contigious block of emm
m_emm_MEM_TOTAL	dw	0		;total emm memory	
ASCII_device_name: db   'EMMXXXX0',0
emm_version	db	'x.x'
		db	'$'		;term for version display
;
