	page	66,132
;******************************** MSG2.ASM   *********************************

LIBSEG           segment byte public "LIB"
		assume cs:LIBSEG , ds:nothing

;----------------------------------------------------------------------------
.xlist
	include  mac.inc
	include  common.inc
.list
comment 
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -( MESSAGE )
random - generate random number
;
;  inputs: bx = minimum value of random range
;          bp = maximum value of random range
;          
;  output: ax = random number
;          all registers are restored except for -ax-
* * * * * * * * * * * * * *

seed	dw	-1

	public	random
random	proc	far
	apush	dx,cx
	mov	ax,cs:seed
	cmp	ax,-1			;check if first entry
	jne	do_rand			; jmp if not first entry
;
; initialize the random seed
;
	mov	cx,ds
	sub	ax,ax
	mov	ds,ax
	mov	ax,ds:[46ch]
	mov	ds,cx

do_rand:mov	cx,1255			;get constant multiplier
	mul	cx
	add	ax,6173			;add constant adjustment factor
	adc	dx,0
	mov	cx,29282		;mod value for ranging
	div	cx
	mov	cs:seed,dx		;store new seed
;
; now convert number to desired range
;
	mov	ax,bp			;get maximum value for range
	sub	ax,bx			;compute range max - min
	mul	cs:seed
	dec	cx
	div	cx
;
; round result
;	
	shr	cx,1
	cmp	cx,dx
	adc	ax,0
	
	add	ax,bx			;add minimum range for final scaling
	apop	cx,dx
	retf
	
random	endp
comment 
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -( MESSAGE )
GET_RANDOM -  generate random number
;
; inputs: (ds:bx)  struc
;                   rs1   dw  (random seed 1)
;                   rs2   dw  (random seed 2)
;                   range dw  mask to truncate number
;                   method db  flag  1 = method 1   2=method 2
;                   
; output:  ax = random number
;
; note:  GET_RANDOM is designed for applications which need to keep several
;        random number sequences going indepently.  Normaly, the
;        RANDOM function is used instead of GET_RANDOM.
;* * * * * * * * * * * * * *


randd	struc
rs1	dw	?
rs2	dw	?
range	dw	?
method	db	?
randd	ends

first_random	db	0
;-------------------------
	public	get_random
get_random	proc	  far
	cmp	cs:first_random,0
	jne	not_first_entry
;
; this is the first call to get_random so initialize the random seeds
;
	push	es
	mov	ax,0
	mov	es,ax
	mov	al,byte ptr es:[46ch]		;get time
	mov	ah,al
;	mov	[bx].rs1,ax
;	mov	[bx].rs2,ax
;	mov	cs:first_random,1
	pop	es

not_first_entry:
;	mov	dx,[bx.rs2]
;	mov	ax,[bx.rs1]
;	mov	[bx.rs2],ax
;	cmp	[bx.method],2
	je	method2
;	cmp	[bx.method],1
gr_err:	jne	gr_err
;
; method 1
;
	add	ax,dx
	rol	ax,1
	jmp	gr_wrap_up
;
; method 2
;
method2:
	mov	cx,171
	mul	cx
	mov	cx,30269
	div	cx
	mov	ax,dx
;
; scale random number
;
gr_wrap_up:
	mov	[bx.rs1],ax		;save for next time
	and	ax,[bx.range]		;scale number
	retf
get_random	endp

LIBSEG	ENDS
	end
