;
; code fragment to convert a byte to decimal 
;
#6 Binary/Decimal Conversion

	aam		;al = ones, ah = tens & hundreds
	mov	cl,al	;Save ones in cl
	mov	al,ah	;Set up to do it again
	aam		;ah = hundreds, al = tens, cl = ones

;------------------------------------------------------------------
DEC8OUT

  Function: This routine accepts an 8-bit binary number in the DL register,
    converts it to ASCII decimal form and sends it to the standard output
    device.

  Input: Upon entry an 8-bit binary number is in the DL register.

  Output: A string of ASCII digits representing a decimal number is stored in
    a buffer called TBUFF and then sent out through the standard output device.

  Registers used: No registers are modified. DL is used for input.

  Segments referenced: DATAS is a data segment which contains TBUFF

  Routines called: STDOUT
;-----------------------------------------------------------------------------
;Routine to convert from internal 8-bit to ASCII decimal
;
DEC8OUT   PROC	 FAR
;
;A binary number is in DL
	  PUSH	 DS		       ;Save registers
	  PUSH	 DI
	  PUSH	 DX
	  PUSH	 CX
	  PUSH	 AX
	  MOV	 AX,DATAS	       ;Point to the data segment
	  MOV	 DS,AX
;
;Put the digits in a buffer
	  MOV	 CX,0		       ;Initialize a counter
	  MOV	 DI,OFFSET TBUFF       ;Point to buffer
DEC8OUT1:
	  PUSH	 CX		       ;Save CX
	  MOV	 AL,DL		       ;AX has numerator
	  MOV	 AH,0		       ;Clear upper half
	  MOV	 CL,10		       ;Divisor of 10
	  DIV	 CL		       ;Divide
	  MOV	 DL,AL		       ;Get quotient
	  MOV	 AL,AH		       ;Get remainder
	  ADD	 AL,30H 	       ;Add 30H
	  MOV	 [DI],AL	       ;Put in buffer
	  INC	 DI		       ;Pointer to next byte
	  POP	 CX		       ;Restore CX
	  INC	 CX		       ;Count the digit
	  CMP	 DL,0		       ;Done ?
	  JNZ	 DEC8OUT1
;
;Dump the buffer out
DEC8OUT2:
	  DEC	 DI		       ;Back up through the buffer
	  MOV	 AL,[DI]	       ;Get the byte from the buffer
	  CALL	 STDOUT 	       ;Send it out
	  LOOP	 DEC8OUT2
	  POP	 AX		       ;Restore registers
	  POP	 CX
	  POP	 DX
	  POP	 DI
	  POP	 DS
	  RET			       ;Return
DEC8OUT ENDP
;----------------------------------------------------------------------------
;
; two code fragments to convert to decimal
;
#6 Binary/Decimal Conversion

	aam		;al = ones, ah = tens & hundreds
	mov	cl,al	;Save ones in cl
	mov	al,ah	;Set up to do it again
	aam		;ah = hundreds, al = tens, cl = ones

-------------

;ah = hundreds, al = tens, cl = ones
	aad		;Combine hundreds and tens
	mov	ah,al
	mov	al,cl	;Move ones to al
	aad		;Binary result in ax, mod 256

;----------------------------------------------------------------------------
; inputs al = binary
;
byte_to_decimal:
	push	ax
	aam			;convert byte to bcd
	or	ax,3030h	;add in ascii
	xchg	al,ah
	call	display_char
	xchg	al,ah
	call	display_char
	pop	ax
	ret  
  
