	page	66,132
;******************************** STR06.ASM  *********************************

LIBSEG           segment byte public "LIB"
		assume cs:LIBSEG , ds:nothing

;----------------------------------------------------------------------------
.xlist
	include  mac.inc
	include  common.inc
.list
;----------------------------------------------------------------------------
	extrn	str_reverse:far
	extrn	DO_SCAN:near
comment 
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -( STRING  )
LAST_STR -  finds the last match with a target string in a source string
;
; inputs:    ES:[DI] pointing to source string
;            DS:[SI] pointing to match string.
;            
; output:    if no carry - BX = offset of target in source string.
;            if carry - no match
;            
; note:      case of strings must also match.
;* * * * * * * * * * * * * *

big_str		label	dword
big_str_off	dw	0
big_str_seg	dw	0

match_str	label	dword
match_str_off	dw	0
match_str_seg	dw	0

	PUBLIC	LAST_STR
LAST_STR	PROC	FAR
    APUSH   AX,CX,DX,DI,SI
    mov	    cs:big_str_off,di
    mov     cs:big_str_seg,es
    mov     cs:match_str_off,si
    mov     cs:match_str_seg,ds

    CALL    STR_REVERSE		;reverse the match string
    MOV     BX,CX		;save the match string length
    
    lds     si,cs:big_str
    CALL    STR_REVERSE		;reverse the big string DS:SI
    MOV     DX,CX		;save big string length
;
; registers ds:si=match string bx=match len,  es:di=big string dx=big str len
;
    lds     si,cs:match_str	;get match string ptr DS:SI
    les     di,cs:big_str	;get big string ptr  ES:DI
    CALL    DO_SCAN
    pushf			;save results
    MOV     AX,BX		;save possible match

    lds     si,cs:match_str    
    CALL    STR_REVERSE		;reverse match string
    mov     bx,cx		;compute length of both strings
    neg     bx

    lds     si,cs:big_str    
    CALL    STR_REVERSE		;reverse big string
    add     bx,CX		;save length of big string?

    popf			;restore DO_SCAN results
    JAE     LS_FOUND		;jmp if string found
    STC
    JMP     LS_EXIT
LS_FOUND:
    sub     ax,si		;si=big_str_off  ax=reverse match
    sub     bx,ax
    add     bx,si		;si=big_str_off
    CLC
LS_EXIT:    
    APOP    SI,DI,DX,CX,AX
    RETF
LAST_STR	ENDP

LIBSEG	ENDS
	end
